const path = require('path');
const common = require('./webpack.config.common');

const genConfig = ({
  entry, filename, library, libraryTarget,
}) => ({
  ...common,
  mode: 'development',
  entry,
  output: {
    filename,
    library,
    libraryTarget,
  },
  devServer: {
    allowedHosts: ['localhost', '.gitpod.io'],
    // https:  {
    //   key: fs.readFileSync(path.resolve(__dirname, '../dist/song.test-key.pem')),
    //   cert: fs.readFileSync(path.resolve(__dirname, '../dist/song.test.pem'))
    // }
  },
});

module.exports = [
  genConfig({
    entry: path.resolve(__dirname, '..', 'src', 'index.js'),
    filename: 'ffmpeg.dev.js',
    library: 'FFmpeg',
    libraryTarget: 'umd',
  }),
];
