const path = require('path');
const webpack = require('webpack');
const common = require('./webpack.config.common');
const fs = require('fs')

// let ssl = await devcert.certificateFor("h5.dev.weidian.com", { getCaPath: true });
// const { key, cert } = ssl;

const genConfig = ({
  entry, filename, library, libraryTarget,
}) => ({
  ...common,
  mode: 'development',
  target: 'webworker',
  entry,
  output: {
    filename,
    library,
    libraryTarget,
  },
  devServer: {
    allowedHosts: ['localhost', '.gitpod.io'],
    // host: 'song.test',
    https:  {
      key: fs.readFileSync(path.resolve(__dirname, '../dist/song.test-key.pem')),
      cert: fs.readFileSync(path.resolve(__dirname, '../dist/song.test.pem'))
    }
  },
});

module.exports = [
  genConfig({
    entry: path.resolve(__dirname, '..', 'src', 'index.js'),
    filename: 'ffmpeg.dev.js',
    library: 'FFmpeg',
    libraryTarget: 'umd',
  }),
];
