const webpack = require('webpack');
const middleware = require('webpack-dev-middleware');
const express = require('express');
const path = require('path');
const cors = require('cors');
const webpackConfig = require('./webpack.config.worker.dev');

const https = require('https');
const fs = require('fs');

const compiler = webpack(webpackConfig);
const app = express();

function coi(req, response, next) {
  // res.setHeader("Cross-Origin-Opener-Policy", "same-origin");
  // res.setHeader("Cross-Origin-Embedder-Policy", "require-corp");
  // res.setHeader()
  response.setHeader("Access-Control-Allow-Origin", "true");
  response.setHeader("Access-Control-Allow-Credentials", "true");
  response.setHeader("Access-Control-Allow-Methods", "POST, GET, OPTIONS, DELETE, HEAD");
  response.setHeader("Access-Control-Max-Age", "3600");
  response.setHeader("Access-Control-Allow-Headers", "access-control-allow-origin, authority, content-type, version-info, X-Requested-With");
  // response.header("Content-Type", "application/json;charset=utf-8");
  next();
}

// app.use(cors());
app.use(coi);

app.use('/', express.static(path.resolve(__dirname, '..')));
app.use(middleware(compiler, { publicPath: '/dist', writeToDisk: true }));

const options = {
  key: fs.readFileSync(path.resolve(__dirname, '../dist/song.test-key.pem')),
  cert: fs.readFileSync(path.resolve(__dirname, '../dist/song.test.pem')),
  header: {
    "Access-Control-Allow-Origin": "true",
    "Access-Control-Allow-Credentials": "true",
    "Access-Control-Allow-Methods": "POST, GET, OPTIONS, DELETE, HEAD",
    "Access-Control-Max-Age": "3600",
    "Access-Control-Allow-Headers": "access-control-allow-origin, authority, content-type, version-info, X-Requested-With",
  }
};

module.exports = https.createServer(options, app)
  .listen(3000, () => console.log(`App listening on port 3000!`));

// module.exports = app.listen(3000, () => {
//   console.log('Server is running on port 3000');
// });
